// see http://vuejs-templates.github.io/webpack for documentation.
var path = require('path')

module.exports = {
  build: {
    env: require('./prod.env'),
    index: path.resolve(__dirname, '../docs/demos/temp/index.html'),
    assetsRoot: path.resolve(__dirname, '../docs/demos/temp'),
    assetsSubDirectory: 'static',
    assetsPublicPath: './',
    productionSourceMap: true,
    // Gzip off by default as many popular static hosts such as
    // Surge or Netlify already gzip all static assets for you.
    // Before setting to `true`, make sure to:
    // npm install --save-dev compression-webpack-plugin
    productionGzip: false,
    productionGzipExtensions: ['js', 'css'],
    // Run the build command with an extra argument to
    // View the bundle analyzer report after build finishes:
    // `npm run build --report`
    // Set to `true` or `false` to always turn it on or off
    bundleAnalyzerReport: process.env.npm_config_report
  },
  dev: {
    env: require('./dev.env'),
    port: 8080,
    autoOpenBrowser: false,
    assetsSubDirectory: 'static',
    assetsPublicPath: '/',
    proxyTable: {},
    // CSS Sourcemaps off by default because relative paths are "buggy"
    // with this option, according to the CSS-Loader README
    // (https://github.com/webpack/css-loader#sourcemaps)
    // In our experience, they generally work as expected,
    // just be aware of this issue when enabling this option.
    cssSourceMap: false
  },
  packageNameList: [
    "bluebird",
    "autoprefixer",
    "babel-core",
    "babel-loader",
    "babel-polyfill",
    "babel-preset-es2015",
    "copy-webpack-plugin",
    "cross-env",
    "css-loader",
    "extract-text-webpack-plugin",
    "file-loader",
    "html-webpack-exclude-assets-plugin",
    "html-webpack-include-assets-plugin",
    "html-webpack-plugin",
    "json-loader",
    "less",
    "less-loader",
    "style-loader",
    "lodash",
    "postcss-loader",
    "promise-loader",
    "scriptjs",
    "surge",
    "url-loader",
    "vue",
    "vue-loader",
    "vue-resource",
    "vue-router",
    "vuex",
    "webpack",
    "webpack-dev-server",
    "webpack-merge",
    "wevue-tools"
  ]
}
