import Vue from 'vue'
import VueRouter from 'vue-router'
import Vuex from 'vuex'

require("babel-polyfill");

let path = require('path')

const appConf = require('./app.json')

let sdk = require('wevue-tools')

import AppView from 'promise?bluebird!./layouts/App.vue'

require('layouts/RegPlugins.vue')


let tools = sdk.tools
window.shoots = sdk.wx;
if (!window.wx) {
    window.wx = sdk.wx;
}
window.Page = sdk.Page;
window.App = sdk.App;
window.getApp = App.getApp;
window.PVAPP = {};
window.PVCI = {};
window.PVTBI = {};//tabbar实例

window.PVBI = {};//backend实例
window.__wxBackendOptions = {}

window.__wxPageOptionsJar = {}
window.__wxPageOptions = {}
window.__wxAppOptions = {}
window.PagePath = '/';

Vue.config.silent = false
Vue.config.errorHandler = function (err, vm) {
    // handle error
    console.error(err);
}
Vue.use(VueRouter)
Vue.use(Vuex)

const routes = tools.getAppRouters(appConf)

const store = new Vuex.Store({
    state: {},
    mutations: {
        setData(state, payload) {
            return Object.assign(state[payload.__this.__PagePath.replace(/\//g, '_')], payload.obj)
        }
    },
    actions: {
        setData(ctx, params) {
            if ('object' !== typeof params) {
                return new Error('setData参数必须是一个state对象')
            }
            return ctx.commit('setData', params)
        }
    },
    modules: {}
})

const router = new VueRouter({
    routes
})

router.beforeEach((to, from, next) => {
    /**
     * @lzq 2017-06-27
     * 先检查路由是否合法，不合法的话跳转到指定页面
     */
    if (tools.beforeRouterEnter(to,from,next)) {
        PagePath = to.path
        var fromStore = ''

        try {
            PVCI[PagePath].$appInstence.$refs.$pageProgressBar.progress = 0
        } catch (e) { }

        if (from.path !== '/') {
            if (PVAPP) {
                if (PVAPP.$store) {
                    fromStore = from.path.replace(/\//g, '_')
                    __wxPageOptions = __wxPageOptionsJar[PagePath]
                }
            }
        }
        next()
    }else{
        next(tools.__getNotFoundPage())
    }

})

router.afterEach((to, from, next) => {
    tools.afterRouterEnter()

    if (from.path === to.path) {
        if (PVCI[PagePath].$componentInstence) {
            tools.pageOnLoad(PVCI[PagePath], { backend: false });
            tools.pageOnReady(PVCI[PagePath], { backend: false });
            tools.pageOnShow(PVCI[PagePath], { backend: false });
        }
    }
})

require('./app.js')  //执行app.js

App.__initApp(function () {
    new Vue({
        store,
        router,
        render: h => h(AppView),
        created: function () {
            // PVAPP = this

            tools.appOnLoad(this)

        },
        mounted: function () {
            // PVAPP = this
            tools.appOnShow(this)

        },
        destroyed: function () {
            tools.appOnHide(this)
        }
    }).$mount("#app")
    let componentsList = require('components/entry')
    for (let ci in componentsList) {
        Vue.component(ci, componentsList[ci])
    }

    let directivesList = require('directives/entry')
    for (let di in directivesList) {
        Vue.directive(di, directivesList[di])
    }
})
